CREATE TABLE NNCARD_ISSUER (
	SIFRA VARCHAR2(2 CHAR), 
    PAYMENT_SYSTEM_CODE VARCHAR2(20 CHAR),
	OPIS VARCHAR2(100 CHAR), 
	INTERNI_OPIS VARCHAR2(100 CHAR), 
	AUTH_DURATION NUMBER,
	ACTIVE VARCHAR2(1 CHAR) DEFAULT 'Y',
	CONSTRAINT PK_NNCARD_ISSUER PRIMARY KEY (SIFRA)
);

INSERT INTO NNCARD_ISSUER (SIFRA, PAYMENT_SYSTEM_CODE, OPIS, INTERNI_OPIS, AUTH_DURATION, ACTIVE) VALUES ('MC', 'MASTERCARD', 'Mastercard', 'Mastercard', 10, 'Y');
INSERT INTO NNCARD_ISSUER (SIFRA, PAYMENT_SYSTEM_CODE, OPIS, INTERNI_OPIS, AUTH_DURATION, ACTIVE) VALUES ('VS', 'VISA', 'Visa', 'Visa', 10, 'Y');
INSERT INTO NNCARD_ISSUER (SIFRA, PAYMENT_SYSTEM_CODE, OPIS, INTERNI_OPIS, AUTH_DURATION, ACTIVE) VALUES ('DC', 'DINERSCLUB', 'Diners Club', 'Diners Club', 10, 'Y');
INSERT INTO NNCARD_ISSUER (SIFRA, PAYMENT_SYSTEM_CODE, OPIS, INTERNI_OPIS, AUTH_DURATION, ACTIVE) VALUES ('AE', 'AMEX', 'American Express', 'American Express', 10, 'Y');
INSERT INTO NNCARD_ISSUER (SIFRA, PAYMENT_SYSTEM_CODE, OPIS, INTERNI_OPIS, AUTH_DURATION, ACTIVE) VALUES ('JC', 'JCB', 'JCB', 'JCB', 10, 'Y');
INSERT INTO NNCARD_ISSUER (SIFRA, PAYMENT_SYSTEM_CODE, OPIS, INTERNI_OPIS, AUTH_DURATION, ACTIVE) VALUES ('DS', 'DISCOVER', 'Discover', 'Discover', 10, 'Y');
INSERT INTO NNCARD_ISSUER (SIFRA, PAYMENT_SYSTEM_CODE, OPIS, INTERNI_OPIS, AUTH_DURATION, ACTIVE) VALUES ('CU', 'CHINAUNIONPAY', 'China Union Pay', 'China Union Pay', 10, 'Y');

UPDATE NNCARDS
SET CARD_ISSUER = 'MC'
WHERE CARD_ISSUER = 'MASTERCARD';

UPDATE NNCARDS
SET CARD_ISSUER = 'VS'
WHERE CARD_ISSUER = 'VISA';

UPDATE NNCARDS
SET CARD_ISSUER = 'DC'
WHERE CARD_ISSUER = 'DINERSCLUB';

UPDATE NNCARDS
SET CARD_ISSUER = 'AE'
WHERE CARD_ISSUER = 'AMEX';

UPDATE NNCARDS
SET CARD_ISSUER = 'JC'
WHERE CARD_ISSUER = 'JCB';

UPDATE NNCARDS
SET CARD_ISSUER = 'DS'
WHERE CARD_ISSUER = 'DISCOVER';

UPDATE NNCARDS
SET CARD_ISSUER = 'CU'
WHERE CARD_ISSUER = 'CHINAUNIONPAY';


UPDATE KUPCI_CREDIT_CARDS
SET CARD_ISSUER = 'MC'
WHERE CARD_ISSUER = 'MASTERCARD';

UPDATE KUPCI_CREDIT_CARDS
SET CARD_ISSUER = 'VS'
WHERE CARD_ISSUER = 'VISA';

UPDATE KUPCI_CREDIT_CARDS
SET CARD_ISSUER = 'DC'
WHERE CARD_ISSUER = 'DINERSCLUB';

UPDATE KUPCI_CREDIT_CARDS
SET CARD_ISSUER = 'AE'
WHERE CARD_ISSUER = 'AMEX';

UPDATE KUPCI_CREDIT_CARDS
SET CARD_ISSUER = 'JC'
WHERE CARD_ISSUER = 'JCB';

UPDATE KUPCI_CREDIT_CARDS
SET CARD_ISSUER = 'DS'
WHERE CARD_ISSUER = 'DISCOVER';

UPDATE KUPCI_CREDIT_CARDS
SET CARD_ISSUER = 'CU'
WHERE CARD_ISSUER = 'CHINAUNIONPAY';


UPDATE PAYMENT_LINK
SET CREDIT_CARD_ISSUER = 'MC'
WHERE CREDIT_CARD_ISSUER = 'MASTERCARD';

UPDATE PAYMENT_LINK
SET CREDIT_CARD_ISSUER = 'VS'
WHERE CREDIT_CARD_ISSUER = 'VISA';

UPDATE PAYMENT_LINK
SET CREDIT_CARD_ISSUER = 'DC'
WHERE CREDIT_CARD_ISSUER = 'DINERSCLUB';

UPDATE PAYMENT_LINK
SET CREDIT_CARD_ISSUER = 'AE'
WHERE CREDIT_CARD_ISSUER = 'AMEX';

UPDATE PAYMENT_LINK
SET CREDIT_CARD_ISSUER = 'JC'
WHERE CREDIT_CARD_ISSUER = 'JCB';

UPDATE PAYMENT_LINK
SET CREDIT_CARD_ISSUER = 'DS'
WHERE CREDIT_CARD_ISSUER = 'DISCOVER';

UPDATE PAYMENT_LINK
SET CREDIT_CARD_ISSUER = 'CU'
WHERE CREDIT_CARD_ISSUER = 'CHINAUNIONPAY';

CREATE OR REPLACE VIEW V_NNCARDS AS (
SELECT NC.ID_CARDS, NC.OPIS, NC.INTERNI_OPIS, NC.VRSTA_DENARJA, NC.VALUTA, NC.PROVIZIJA, NC.KONTO, NC.KNJIZBA_OPIS, NC.STORITEV, NC.SUBLEASE, 
NC.USE_PAYMENT_SYSTEM, NC.CARD_ISSUER, NC.REFUND, NC.MOBILE_USE, NC.VBLAGAJNI, NC.ROUNDING,
PI.OPIS AS PLATNI_INSTRUMENTI_OPIS, PI.VRSTA AS PLATNI_INSTRUMENTI_VRSTA, MS.OPIS AS NNSTOMAR_OPIS, PS.OPIS AS PAYMENT_SYSTEM_OPIS, CI.OPIS AS CARD_ISSUER_OPIS
FROM NNCARDS NC
LEFT OUTER JOIN PLATNI_INSTRUMENTI PI ON PI.PLATNI_INSTRUMENT = NC.VRSTA_DENARJA
LEFT OUTER JOIN M_NNSTOMAR MS ON MS.SIFRA = NC.STORITEV
LEFT OUTER JOIN NNPAYMENT_SYSTEM PS ON PS.SIFRA =  NC.USE_PAYMENT_SYSTEM
LEFT OUTER JOIN NNCARD_ISSUER CI ON CI.SIFRA =  NC.CARD_ISSUER
);

CREATE OR REPLACE VIEW V_KUPCI_CREDIT_CARDS  AS (
SELECT KC.ID_KUPCI_CC, KC.ID_KUPCA, KC.ID_CARDS, KC.CARD_ISSUER, KC.CARD_NUMBER, KC.SEC_CODE, KC.CARD_OWNER, KC.CARD_EXPIRE, KC.PREFERRED, KC.ACTIVE,
K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, N.OPIS AS CARDS_OPIS, N.INTERNI_OPIS AS CARDS_INTERNI_OPIS, CCT.TOKEN AS CREDIT_CARD_TOKEN, CI.OPIS AS CARD_ISSUER_OPIS
FROM KUPCI_CREDIT_CARDS KC
LEFT OUTER JOIN KUPCI K ON K.ID = KC.ID_KUPCA
LEFT OUTER JOIN NNCARDS N ON N.ID_CARDS = KC.ID_CARDS
LEFT OUTER JOIN CREDIT_CARD_TOKEN CCT ON CCT.ID = KC.ID_CREDIT_CARD_TOKEN
LEFT OUTER JOIN NNCARD_ISSUER CI ON CI.SIFRA =  KC.CARD_ISSUER
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1152, SYSDATE, '5.5', 1072, 'NncardIssuer')
;